/*  this program for Sharp SLA300, B500, C7x0, C860 Linux PDA
	Copyright (C) 2003, 2004 Joe Kanemori.<kanemori@ymg.urban.ne.jp>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundatibannwaon; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include <qwidget.h>
#include "formbase.h"

/* 
 *  Constructs a Example which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f' 
 */
FormBase::FormBase(QWidget* parent,  const char* name, WFlags fl )
    : QMainWindow( parent, name, fl ), bgcolor_(white)
{
	this->setBackgroundMode(NoBackground);
	wbuf_.resize(240, 320);
}

/*  
 *  Destroys the object and frees any allocated resources
 */
FormBase::~FormBase()
{
    // no need to delete child widgets, Qt does it all for us
}


/*
 *  Painting event.
 */
void FormBase::paintEvent(QPaintEvent*)
{
	bitBlt(this, 0, 0, &wbuf_);
}


/*
 *  Painting event.
 */
void FormBase::resizeEvent(QResizeEvent* evt)
{
	QPixmap save(wbuf_);
	wbuf_.resize(evt->size());
	wbuf_.fill(bgcolor_);
	bitBlt(&wbuf_, 0, 0, &save);
	redraw();
}


/*
 *  Redraw method.
 */
void FormBase::redraw()
{
	wbuf_.fill(bgcolor_);
	QPainter pa;
	pa.begin(&wbuf_);
	drawImpl(pa);
	pa.end();
	repaint();
}


/*
 *  Redraw Implement
 */
void FormBase::drawImpl(QPainter& pa)
{
	pa.flush();
}
