/*  this program for Sharp SLA300, B500, C7x0, C860 Linux PDA
	Copyright (C) 2003, 2004 Joe Kanemori.<kanemori@ymg.urban.ne.jp>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundatibannwaon; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <qbitmap.h>
#include <qmessagebox.h>
#include <qmenubar.h>

//#include <sl/slsoundconf.h>
//#include <pthread.h>

#include "frmmain.h"
#define VERSION "0.5"

/*
pthread_t mythread;

void *sound_func(void *arg)
{
	char* fname = (char*)arg;
	char cvbuf[1024];
	sprintf(cvbuf, "cat %s > /dev/dsp", fname);
	system(cvbuf);
	SlSoundPlayer::play(fname, false);
	return NULL;
}


void Play(char* fname)
{
	pthread_create(&mythread, NULL, sound_func, (void*)fname);
}
*/


/* 
 *  Constructs a Example which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f' 
 */
FrmMain::FrmMain( QWidget* parent,  const char* name, WFlags fl )
    : FormBase( parent, name, fl )
{
	SetBGColor(QColor(0, 0, 64));

	QPixmap* p = new QPixmap((const char**)player_xpm);
	player_.setSize(p->width(), p->height());
	player_.addImage(p);
	player_.addImage(new QPixmap((const char**)zan_xpm));

	p = new QPixmap((const char**)enemy_xpm);
	enemy_.setSize(p->width(), p->height());
	enemy_.addImage(p);

	img_moon_ = QPixmap((const char**)moon_xpm);
	img_cloud_ = QPixmap((const char**)cloud_xpm);
	img_pampas_ = QPixmap((const char**)pampas_xpm);
	img_enemy_zan_ = QPixmap((const char**)enemy_zan_xpm);
	img_title_ = QPixmap((const char**)title_xpm);
	player_zan_ = 0;
	enemy_zan_ = 0;
	// 1/4OiFFFFFFFFFFFFF
	// 1/4ށFBBBBBBBBBBBB
	// 1/4ᑬFFSFSFSFSFSFS
	// 1/4ށFBSBSBSBSBSBS
	// 1/4FFSSFSSFSSFSSFSSFSS
	// 1/4ށFBSSBSSBSSBSSBSSBSS
	//    ؁FSSSSSSSS
	patterns_ = 0;
	movepat_[patterns_++] = "";
	movepat_[patterns_++] = "FSSFSSFSSFSSFSSFSSFSSFSSFSSFSSFSSFSSFSSFSSFSSFSSFSSFSSFSSFSS";
	movepat_[patterns_++] = "FSSFSSFSSFSSFSSFSSFSSFSSFSSFSSFSSFSSFSSFSSFSSFSSFSSFSSFSSFSSBBBBBBB";
	movepat_[patterns_++] = "FSSFSSFSSFSSFSSFSSFSSFSSFSSFSSFSSFSSFSSFSSFSSFSSFSSFSSFSSFSSBSSBSSBSSBSSBSSBSSBSS";
	movepat_[patterns_++] = "FSSFSSFSSFSSFSSFSS";
	movepat_[patterns_++] = "FFFFFFFFFFFFBBBBBBBBBBBB";
	movepat_[patterns_++] = "FFFFFFFFFFFFBBBBBBBBBBBBSSSSSSSS";
	movepat_[patterns_++] = "FFFFFFFFFFFFFFFFFFFFFFFFBB";
	movepat_[patterns_++] = "FFFFFFFFFFFFFFFFFFFFFFFFBB";
	movepat_[patterns_++] = "FFFFFFFFFFFFBBFFFFFFFFFFFFBB";
	movepat_[patterns_++] = "FFFFFFFFFFFFBBSSSSSFFFFFFFFFFFFBB";
	movepat_[patterns_++] = "FFFFFFFFFFFFBBSSSSSFFFFFFFFFFFFBBSSSSS";
	movepat_[patterns_++] = "FFFFFFFFFFFFBBFFFFFFFFFFFFBBSSSSS";
	movepat_[patterns_++] = "FFFFFFFFFFFFFFFFFFFFFFFFBBBBBBBB";
	movepat_[patterns_++] = "FFFFFFFFFFFFBBBBBBBBFSSFSSFSSFSSFSSFSSFSS";
	movepat_[patterns_++] = "FSSFSSFSSFSSFSSFSSFSSFFFFFFFFFSFSFSFSFSFSFS";
	movepat_[patterns_++] = "FFFFFFFFFFFFFFFFFFFFFFFFBBBBBBBBBBBBBBBBBBBBBBBB";
	movepat_[patterns_++] = "FFFFFFFFFFFFFFFFFFFFFFFFBBBBBBBBBBBBBBBBBBBBBBBBSSSSSSSSS";
	movepat_[patterns_++] = "FFFFFFFFFFFFFFFFFFFFFFFFBBBBBBBBBBBBBBBBBBBBBBBBFFFFFFFFFFFFSSSSSSSSS";
	movepat_[patterns_++] = "FFFFFFFFFFFFSSDD";
	movepat_[patterns_++] = "FFFFFFFFFFFFBBSSDD";
	movepat_[patterns_++] = "FFFFFFFFFFFFFFFFFFFFFFFFSSDDDD";
	movepat_[patterns_++] = "FFFFFFFFFFFFBBBBBBBBBBBBSSSSSSSSDDDDDD";
	movepat_[patterns_++] = "FFFFFFFFFFFFBBBBBBBBBBBBSSDDDDDDBB";
	movepat_[patterns_++] = "FSSFSSFSSFSSFSSFSSFSSFSSFSSFSSFSSFSSFSSFSSFSSFSSFSSFSSFSSFSSDDDDDDDDD";


	refresh_ = new QTimer(this);
	connect(refresh_, SIGNAL(timeout()), this, SLOT(myRefresh()));
	refresh_->start(60);
	for (int i = 0; i < 3; ++i) {
		cx_[i] = rand() % 200;
		cy_[i] = rand() % 50;
		cs_[i] = rand() % 2 + 1;
	}
	playState_ = ST_TITLE;
	timEnemy_ = new QTimer(this);
	connect(timEnemy_, SIGNAL(timeout()), this, SLOT(enemyMove()));
	hiScore_ = 0;
	preWidth_ = -1;
	isDead_ = true;
	round_ = 1;
	SetTitle();
	
	this->menuBar()->insertItem("About", this, SLOT(showAbout()));
}


/*  
 *  Destroys the object and frees any allocated resources
 */
FrmMain::~FrmMain()
{
    // no need to delete child widgets, Qt does it all for us
}


//^Cgݒ
void FrmMain::SetTitle()
{
	char cvbuf[1024];
	sprintf(cvbuf, "IaiMaster - hi:%d", hiScore_);
	setCaption(cvbuf);
}


//Q[Jn
void FrmMain::GameStart()
{
	if (isDead_) {
		isDead_ = false;
		score_ = 0;
		round_ = 1;
	}
	playState_ = ST_PLAYING;
	Reset();
	timEnemy_->stop();
	timEnemy_->start(60);
}


//l
void FrmMain::Reset()
{
	player_.X = left_;
	enemy_.X = right_;
	points_ = 0;
	moves_ = movepat_[rand() % patterns_];
	player_zan_ = 0;
	enemy_zan_ = 0;
	player_jump_ = 0;
	enemy_jump_ = 0;
	isEnemyZan_ = false;
	isEnemyJumped_ = false;
	cnt_color_ = 255;
}


//G쏈
void FrmMain::enemyMove()
{
	QString cmd = "";
	switch (playState_) {
	case ST_PLAYING:
		cmd = moves_.left(1);
		moves_ = moves_.mid(2);
		if (cmd == "") {
			//I
			enemy_.X -= 10;
			if (enemy_.X - enemy_.width() <= left_) {
				timEnemy_->stop();
				playState_ = ST_WAITING;
			}
		} else if (cmd == "F") {
			enemy_.X -= 5;
		} else if (cmd == "D") {
			enemy_.X -= 15;
		} else if (cmd == "B") {
			enemy_.X += 5;
		}
		if (enemy_.X - enemy_.width() <= player_.X + player_.width()) {
			if (0 == points_) {
				enemy_zan_ = 3;
				isEnemyZan_ = true;
			}
			playState_ = ST_WAITING;
		}
		break;
	case ST_WAITING:
		enemy_.X -= 10;
		if (!isEnemyZan_ && 0 == points_) {
			if (enemy_.X - enemy_.width() <= player_.X + player_.width()) {
				enemy_zan_ = 3;
				isEnemyZan_ = true;
			}
		}
		if (enemy_.X - enemy_.width() <= left_) {
			timEnemy_->stop();
		}
		break;
	}
}


//Aj
void FrmMain::myRefresh()
{
	for (int i = 0; i < 3; ++i) {
		cx_[i] = cx_[i] - cs_[i];
		if (0 >= cx_[i] + img_cloud_.width()) {
			cx_[i] = width();
			cy_[i] = rand() % 50;
			cs_[i] = rand() % 2 + 1;
		}
	}
	if (playState_ == ST_WAITING) {
		player_.X += 10;
		if (player_.X > right_ - player_.width()) {
			player_.X = right_ - player_.width();
			playState_ = ST_ENDING;
			player_jump_ = 0;
			enemy_jump_ = 0;
			if (0 == points_) {
				isDead_ = true;
			} else {
				++round_;
				score_ += points_;
				if (score_ > hiScore_) {
					hiScore_ = score_;
					SetTitle();
				}
			}
		}
	} else if (playState_ == ST_PLAYING) {
		int ex = enemy_.X - enemy_.width();
		if (player_.X < ex && player_[1].width() + 20 > (ex - player_.X) && 0 == enemy_jump_ && !isEnemyJumped_) {
			if (rand() % 100 < 15) {
				enemy_jump_ = 10;
				isEnemyJumped_ = true;
			}
		}
	}
	redraw();
}


/*
void FrmMain::playSound()
{
	SlSoundPlayer::play("/mnt/card/sword.wav");
}
*/


//a
bool FrmMain::ZanJudge(QMouseEvent* evt)
{
	int r = (int)sqrt((px_ - evt->x())*(px_ - evt->x()) + (py_ - evt->y())*(py_ - evt->y()));
	if (20 < r) {
		//timSound_->start(1, true);
		//Play("/mnt/card/sword.wav");
		player_zan_ = 3;
		redraw();
		playState_ = ST_WAITING;
		int w1 = player_[0].width(); 
		int w2 = player_[1].width();
		if (height() / 2 > evt->y() && 0 == player_jump_) {
			player_jump_ = 10;
		}
		if (enemy_.X - enemy_.width() <= player_.X + w2 && (enemy_.X - enemy_.width()) >= player_.X + w1 && ((0 == player_jump_) == (0 == enemy_jump_))) {
			points_ = enemy_.X - enemy_.width() - player_.X + 1 + round_ * 50 + (player_.X - left_) / 2;
		}
		return true;
	}
	return false;
}


//}EXMOVE
void FrmMain::mouseMoveEvent(QMouseEvent *evt)
{
	if (playState_ == ST_PLAYING) {
		ZanJudge(evt);
	}
}


//}EX[X
void FrmMain::mouseReleaseEvent(QMouseEvent *evt)
{
	if (playState_ == ST_PLAYING) {
		if (!ZanJudge(evt)) {
			if (player_.X <= evt->x()) {
				player_.X += 10;
				if (player_.X >= right_) {
					player_.X = right_;
				}
			} else {
				player_.X -= 10;
				if (player_.X <= left_) {
					player_.X = left_;
				}
			}
			if (player_.X + player_.width() > enemy_.X - enemy_.width()) {
				playState_ = ST_WAITING;
				if (0 == points_) {
					enemy_zan_ = 3;
					isEnemyZan_ = true;
				}
			}
		}
	}
}


//}EXON
void FrmMain::mousePressEvent(QMouseEvent* evt)
{
	px_ = evt->x();
	py_ = evt->y();
	switch (playState_) {
	case ST_TITLE:
		GameStart();
		break;
	case ST_ENDING:
		Reset();
		playState_ = ST_TITLE;
		break;
	}
}


//`揈
void FrmMain::drawImpl(QPainter& pa)
{
	int wx = width();
	int wy = height();
	int dx = img_pampas_.width();
	int dh = img_pampas_.height();
	int cy = wy - 4 * dh / 3;

	//Ajpyݒ
	pa.setPen(QPen(QColor(cnt_color_, 0, 0)));
	cnt_color_ -= 5;
	if (120 >= cnt_color_) {
		cnt_color_ = 255;
	}

	//\̈ύX
	if (preWidth_ != wx) {
		left_ = (wx - 240) / 2;
		right_ = wx - left_;
		if (playState_ == ST_TITLE) {
			Reset();
			playState_ = ST_TITLE;
		}
		preWidth_ = wx;
		player_.Y = cy - player_.height() / 2;
		enemy_.Y = cy - enemy_.height() / 2;

		//XXLOtBbN쐬
		img_pampases_ = QPixmap(wx + dx * 4, dh);
		QBitmap mask(wx + dx * 4, dh); //}XN

		QPainter pa(&img_pampases_);
		QPainter pm(&mask);
		for (int i = 0; i < wx + dx * 4; i += dx) {
			pa.drawPixmap(i, 0, img_pampas_); //XXL`
			pm.drawPixmap(i, 0, *img_pampas_.mask()); //}XN쐬
		}
		img_pampases_.setMask(mask); //ߗp̃}XNݒ
	}

	//\
	pa.drawPixmap(wx / 2 - img_moon_.width() / 2, wy / 5, img_moon_);
	for (int i = 0; i < 3; ++i) {
		pa.drawPixmap(cx_[i], wy / 5 + cy_[i], img_cloud_);
	}

	int pbias = 0;
	int ebias = 0;
	static char cvbuf[1024];
	if (ST_ENDING == playState_) {
		if (0 == points_) {
			pbias = player_[0].height() / 3;
		} else {
			ebias = enemy_[0].height() / 3;
		}
		if (isDead_) {
			//X^[g\
			int w = pa.fontMetrics().width("Tap to title.");
			pa.drawText((wx - w) / 2, wy / 2 + 40, "Tap to title.");
			
			pa.setPen(QPen(white));
			w = pa.fontMetrics().width("game is over.");
			pa.drawText((wx - w) / 2, wy / 2, "game is over.");
			sprintf(cvbuf, "your score is %d", score_);
			w = pa.fontMetrics().width(cvbuf);
			pa.drawText((wx - w) / 2, wy / 2 + 20, cvbuf);

			round_ = 1;
		} else {
			//Eh
			int w = pa.fontMetrics().width("Tap to next round.");
			pa.drawText((wx - w) / 2, wy / 2, "Tap to next round.");
		}
	} else if (ST_TITLE == playState_) {
		if (isDead_) {
			//^Cg\
			pa.drawPixmap((wx - img_title_.width()) / 2, wy / 5 - img_title_.height() / 2, img_title_);
		}
		sprintf(cvbuf, "Tap to start round %d", round_);
		int w = pa.fontMetrics().width(cvbuf);
		pa.drawText((wx - w) / 2, wy / 2, cvbuf);
	}

	//enemy`
	if (0 < enemy_jump_) {
		--enemy_jump_;
	}
	pa.drawPixmap(enemy_.X - enemy_.width(), ebias + enemy_.Y - enemy_jump_ * 10, enemy_[0]);
	if (0 < player_jump_) {
		--player_jump_;
	}

	//player`
	if (player_zan_ > 0) {
		//a
		pa.drawPixmap(player_.X, pbias + player_.Y - player_jump_ * 10, player_[1]);
		--player_zan_;
	} else {
		//ړ
		pa.drawPixmap(player_.X, pbias + player_.Y - player_jump_ * 10, player_[0]);
	}

	if (enemy_zan_ > 0) {
		//Ga
		pa.drawPixmap(enemy_.X - enemy_.width() - 20, ebias + enemy_.Y - enemy_jump_ * 10 - 20, img_enemy_zan_);
		--enemy_zan_;
	}

	//XXL\
	for (int i = 4; 0 <= i; --i) {
		int mx = 0;
		if (0 == i % 2) {
			mx = cx_[0] % 2;
		}
		pa.drawPixmap(i * 10 + mx - dx * 4, wy - i * dh / 3, img_pampases_);
	}
}


//About\
void FrmMain::showAbout()
{
	char cvbuf[1024];	
	sprintf(cvbuf, "Iai-Master\nver.%s\ncopyright(c) 2004,jojo3.", VERSION);
	QMessageBox::about(this, "Iai-Master", cvbuf);
}
