/*  this program for Sharp SLA300, B500, C7x0, C860 Linux PDA
	Copyright (C) 2003, 2004 Joe Kanemori.<kanemori@ymg.urban.ne.jp>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundatibannwaon; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef  FRMMAIN_H
#define  FRMMAIN_H
#include <qtimer.h>
#include <qsound.h>
//#include <sl/slsoundconf.h>
#include "formbase.h"
#include "icon.h"
#include "sprite.h"

#define ST_TITLE (0)
#define ST_READY (1)
#define ST_PLAYING (2)
#define ST_WAITING (3)
#define ST_ENDING (4)


class FrmMain : public FormBase
{ 
    Q_OBJECT

public:
    FrmMain( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
    ~FrmMain();

	virtual void mouseReleaseEvent(QMouseEvent* evt);	//}EXON
	virtual void mousePressEvent(QMouseEvent* evt);		//}EX[X
	virtual void mouseMoveEvent(QMouseEvent* evt);		//}EXMOVE

protected:
	virtual void drawImpl(QPainter& pa);	//`揈

private slots:
	void myRefresh();			//Aj
	void enemyMove();			//G쏈
	void Reset();				//l
	void GameStart();			//Q[Jn
	void showAbout();			//AoEg\
	//void playSound();
private:
	void SetTitle();					//^Cgݒ
	bool ZanJudge(QMouseEvent* evt);	//a
	Sprite player_;				//vC[
	Sprite enemy_;				//G

	QPixmap img_moon_;			//摜F
	QPixmap img_cloud_;			//摜F_
	QPixmap img_pampas_;		//摜FXXL
	QPixmap img_enemy_zan_;		//摜FGa
	QPixmap img_title_;			//摜F^Cg
	QPixmap img_pampases_;		//摜FXXL
	QString movepat_[100];		//Gp^[
	QString moves_;				//

	QTimer* refresh_;			//`^C}[
	QTimer* timEnemy_;			//G^C}[
	//QTimer* timSound_;

	int playState_;				//Q[

	int cs_[3];					//_Xs[h
	int cx_[3];					//_XW
	int cy_[3];					//_YW

	int px_;					//OXW(aɎgp)
	int py_;					//OYW(aɎgp)

	int points_;				//EhXRA

	int player_zan_;			//vC[a\JEg
	int enemy_zan_;				//Ga\JEg

	int enemy_jump_;			//GWv\JEg
	int player_jump_;			//vC[Wv\JEg

	int patterns_;				//p^[

	bool isEnemyZan_;			//GatO
	bool isEnemyJumped_;		//GWvtO
	bool isDead_;				//vC[StO

	int hiScore_;				//nCXRA
	int score_;					//XRA

	int round_;					//Eh

	int left_;					//[W
	int right_;					//E[W

	int preWidth_;				//O擾ʕ(𑜓x؊ւ̑Ή)

	int cnt_color_;				//Aj[Vpϐ
	//SlSoundPlayer wav_;
};

#endif //FRMMAIN_H
